import de.bb.util.IntegerStack;

class Calc3 extends de.bb.bex.BnfLex
{
  IntegerStack operand  = new IntegerStack();
  IntegerStack operator = new IntegerStack();
  
  // hard coded nonterminal for numbers
  boolean isNumber()throws Exception
  {
    if (type != LX_INT)
      return false;
    next();
    return true;
  }
  
  // override run...
  public boolean run(String args[]) throws Exception
  {
    boolean f = super.run(args);
    if (f)
      System.out.println("= " + operand.pop());
    return f;
  }
  
  // calulate the expression
  void calculate()
  {
    while(operand.size() > 1)
    {
      // now we have two operands on the operand stack
      int right = operand.pop();
      int left  = operand.pop();
      int result = 0;

      // perform calculation
      switch (operator.pop())
      {
        case '+': result = left + right; break;
        case '-': result = left - right; break;
        case '*': result = left * right; break;
        case '/': result = left / right; break;
        case '^':
          result = 1;
          while (right-- > 0)
            result *= left;
          break;
      }

      // and push the result
      operand.push(result);
    }
  }  
}